<?php
/**
* @package		EasyBlog
* @copyright	Copyright (C) Stack Ideas Sdn Bhd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* EasyBlog is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/
defined('_JEXEC') or die('Unauthorized Access');

class SppagebuilderAddonEB_post extends SppagebuilderAddons
{
	public function render()
	{
		$settings = $this->addon->settings;

		$class = (isset($settings->class) && $settings->class) ? $settings->class : '';
		$style = (isset($settings->style) && $settings->style) ? $settings->style : 'panel-default';
		$title = (isset($settings->title) && $settings->title) ? $settings->title : '';
		$heading_selector = (isset($settings->heading_selector) && $settings->heading_selector) ? $settings->heading_selector : 'h3';

		$catid = (isset($settings->catid) && $settings->catid) ? $settings->catid : 0;
		$tagids = (isset($settings->tagids) && $settings->tagids) ? $settings->tagids : array();
		$post_type = (isset($settings->post_type) && $settings->post_type) ? $settings->post_type : null;
		$include_subcat = (isset($settings->include_subcat)) ? $settings->include_subcat : 1;
		$ordering = (isset($settings->ordering) && $settings->ordering) ? $settings->ordering : 'latest';
		$limit = (isset($settings->limit) && $settings->limit) ? $settings->limit : 3;
		$columns = (isset($settings->columns) && $settings->columns) ? $settings->columns : 3;
		$show_intro = (isset($settings->show_intro)) ? $settings->show_intro : 1;
		$link_articles = (isset($settings->link_articles)) ? $settings->link_articles : 0;
		$link_catid = (isset($settings->link_catid)) ? $settings->link_catid : 0;
		$readmore_text = (isset($settings->readmore_text) && $settings->readmore_text) ? $settings->readmore_text : 'COM_EASYBLOG_READ_MORE';

		$intro_limit = (isset($settings->intro_limit) && $settings->intro_limit) ? $settings->intro_limit : 200;
		$hide_thumbnail = (isset($settings->hide_thumbnail)) ? $settings->hide_thumbnail : 0;
		$show_author = (isset($settings->show_author)) ? $settings->show_author : 1;
		$show_category = (isset($settings->show_category)) ? $settings->show_category : 1;
		$show_date = (isset($settings->show_date)) ? $settings->show_date : 1;
		$show_readmore = (isset($settings->show_readmore)) ? $settings->show_readmore : 1;

		$all_articles_btn_text = (isset($settings->all_articles_btn_text) && $settings->all_articles_btn_text) ? $settings->all_articles_btn_text : 'See all posts';
		$all_articles_btn_class = (isset($settings->all_articles_btn_size) && $settings->all_articles_btn_size) ? ' sppb-btn-' . $settings->all_articles_btn_size : '';
		$all_articles_btn_class .= (isset($settings->all_articles_btn_type) && $settings->all_articles_btn_type) ? ' sppb-btn-' . $settings->all_articles_btn_type : ' sppb-btn-default';
		$all_articles_btn_class .= (isset($settings->all_articles_btn_shape) && $settings->all_articles_btn_shape) ? ' sppb-btn-' . $settings->all_articles_btn_shape: ' sppb-btn-rounded';
		$all_articles_btn_class .= (isset($settings->all_articles_btn_appearance) && $settings->all_articles_btn_appearance) ? ' sppb-btn-' . $settings->all_articles_btn_appearance : '';
		$all_articles_btn_class .= (isset($settings->all_articles_btn_block) && $settings->all_articles_btn_block) ? ' ' . $settings->all_articles_btn_block : '';
		$all_articles_btn_icon = (isset($settings->all_articles_btn_icon) && $settings->all_articles_btn_icon) ? $settings->all_articles_btn_icon : '';
		$all_articles_btn_icon_position = (isset($settings->all_articles_btn_icon_position) && $settings->all_articles_btn_icon_position) ? $settings->all_articles_btn_icon_position: 'left';

		$output = '';

		$file = JPATH_ADMINISTRATOR . '/components/com_easyblog/includes/easyblog.php';

		if (!JFile::exists($file)) {
			return '<p class="alert alert-danger">' . JText::_('EasyBlog component is not found.') . '</p>';
		}

		require_once($file);

		$items = $this->getPosts([
			'type' => $post_type,
			'sort' => $ordering,
			'count' => $limit,
			'includeCats' => $catid,
			'includeSubCats' => $include_subcat,
			'includeTags' => $tagids
		]);

		if (count((array) $items)) {
			$output  .= '<div class="sppb-addon sppb-addon-articles ' . $class . '">';

			if ($title) {
				$output .= '<' . $heading_selector . ' class="sppb-addon-title">' . $title . '</' . $heading_selector . '>';
			}

			$output .= '<div class="sppb-addon-content">';
			$output	.= '<div class="sppb-row">';

			foreach ($items as $key => $item) {
				$output .= '<div class="sppb-col-sm-' . round(12 / $columns) . '">';
				$output .= '<div class="sppb-addon-article">';

				if (!$hide_thumbnail) {
					if ($item->posttype == 'video' && isset($item->video_src) && $item->video_src) {
						$output .= '<div class="entry-video o-aspect-ratio" style="--aspect-ratio: 16/9;">';
							$output .= '<object class="" style="width:100%;height:100%;" data="' . $item->video_src . '">';
								$output .= '<param name="movie" value="' . $item->video_src . '">';
								$output .= '<param name="wmode" value="transparent" />';
								$output .= '<param name="allowFullScreen" value="true">';
								$output .= '<param name="allowScriptAccess" value="always"></param>';
								$output .= '<embed src="' . $item->video_src . '" type="application/x-shockwave-flash" allowscriptaccess="always"></embed>';
							$output .= '</object>';
						$output .= '</div>';
					}
					else if ($item->posttype == 'audio' && isset($item->audio_embed) && $item->audio_embed) {
						$output .= '<div class="entry-audio embed-responsive embed-responsive-16by9">';
						$output .= $item->audio_embed;
						$output .= '</div>';
					}
					else if ($item->posttype == 'link' && isset($item->link_url) && $item->link_url) {
						$output .= '<div class="entry-link">';
						$output .= '<a target="_blank" rel="noopener noreferrer" href="' . $item->link_url . '"><h4>' . $item->link_title . '</h4></a>';
						$output .= '</div>';
					}
					else {
						//Lazyload image
						$output .= '<a class="sppb-article-img-wrap" href="' . $item->getPermalink() . '" itemprop="url"><img class="sppb-img-responsive sppb-element-lazy" src="' . $item->getImage() . '" alt="' . $item->getTitle() .'" itemprop="thumbnailUrl" data-large="' . $item->getImage() .'" loading="lazy"></a>';
					}
				}

				$output .= '<div class="sppb-article-info-wrap">';
				$output .= '<h3><a href="' . $item->getPermalink() . '" itemprop="url">' . $item->getTitle() . '</a></h3>';

				if ($show_author || $show_category || $show_date) {
					$output .= '<div class="sppb-article-meta">';

					if ($show_date) {
						$output .= '<span class="sppb-meta-date" itemprop="datePublished">' . Jhtml::_('date', $item->getPublishDate()->toSql(), 'DATE_FORMAT_LC3') . '</span>';
					}

					if ($show_category) {
						foreach ($item->getCategories() as $category) {
							$output .= '<span class="sppb-meta-category"><a href="' . $category->getPermalink() . '" itemprop="genre">' . $category->getTitle() . '</a></span>';
						}
					}

					if ($show_author) {
						$output .= '<span class="sppb-meta-author" itemprop="name">' . $item->getAuthorName() . '</span>';
					}

					$output .= '</div>';
				}

				if ($show_intro) {
					$output .= '<div class="sppb-article-introtext">' . mb_substr(strip_tags($item->getIntro(false, false)), 0, $intro_limit, 'UTF-8') . '...</div>';
				}

				if ($show_readmore) {
					$output .= '<a class="sppb-readmore" href="' . $item->getPermalink() .'" itemprop="url">' . JText::_($readmore_text) . '</a>';
				}

				$output .= '</div>'; //.sppb-article-info-wrap

				$output .= '</div>';
				$output .= '</div>';

			}

			$output  .= '</div>';

			// See all link
			if ($link_articles) {
				$icon_arr = array_filter(explode(' ', $all_articles_btn_icon));

				if (count($icon_arr) === 1) {
					$all_articles_btn_icon = 'fa ' . $all_articles_btn_icon;
				}

				if ($all_articles_btn_icon_position == 'left') {
					$all_articles_btn_text = ($all_articles_btn_icon) ? '<i class="' . $all_articles_btn_icon . '" aria-hidden="true"></i> ' . $all_articles_btn_text : $all_articles_btn_text;
				} else {
					$all_articles_btn_text = ($all_articles_btn_icon) ? $all_articles_btn_text . ' <i class="' . $all_articles_btn_icon . '" aria-hidden="true"></i>' : $all_articles_btn_text;
				}

				if (!empty($link_catid)) {
					$output  .= '<a href="' . EBR::_('index.php?option=com_easyblog&view=categories&id=' . $link_catid . '&layout=listings') . '" id="btn-' . $this->addon->id . '" class="sppb-btn' . $all_articles_btn_class . '">' . $all_articles_btn_text . '</a>';
				}

			}

			$output  .= '</div>';
			$output  .= '</div>';
		}

		return $output;
	}

	public function getPosts($options = [])
	{
		$categories	= EB::normalize($options, 'includeCats', []);
		$catIds = array();

		if (!empty($categories)) {
			if (!is_array($categories)) {
				$categories	= array($categories);
			}

			foreach ($categories as $item) {
				if (!$item) {
					continue;
				}

				$category = new stdClass();
				$category->id = trim( $item );

				$catIds[] = $category->id;

				if (EB::normalize($options, 'includeSubCats', false)) {
					$category->childs = null;
					EB::buildNestedCategories($category->id, $category , false , true );
					EB::accessNestedCategoriesId($category, $catIds);
				}
			}

			$catIds = array_unique($catIds);
		}

		$cid = $catIds;

		$type = EB::normalize($options, 'type', 'latest');

		if (!empty($cid)) {
			$type = 'category';
		}

		$model = EB::model('Blog');
		$data = $model->getBlogsBy($type, $cid, [EB::normalize($options, 'sort', 'latest'), 'DESC'], EB::normalize($options, 'count', 0), EBLOG_FILTER_PUBLISHED, null, true, [], false, false, true, [], $cid, null, 'listlength', true, [], [], false, EB::normalize($options, 'includeTags', 0), ['paginationType' => 'none']);

		$posts = EB::formatter('list', $data, false);

		return $posts;
	}
}
